const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const memoriais_descritivos_asbuilt = sequelize.define(
    'memoriais_descritivos_asbuilt',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      titulo: {
        type: DataTypes.TEXT,
      },

      descricao: {
        type: DataTypes.TEXT,
      },

      arquivo_digital: {
        type: DataTypes.TEXT,
      },

      data_entrega: {
        type: DataTypes.DATEONLY,

        get: function () {
          return this.getDataValue('data_entrega')
            ? moment.utc(this.getDataValue('data_entrega')).format('YYYY-MM-DD')
            : null;
        },
      },

      responsavel_tecnico: {
        type: DataTypes.TEXT,
      },

      validado_por_copasa: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      comentarios_validacao: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  memoriais_descritivos_asbuilt.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.memoriais_descritivos_asbuilt.belongsTo(db.obras, {
      as: 'obra',
      foreignKey: {
        name: 'obraId',
      },
      constraints: false,
    });

    db.memoriais_descritivos_asbuilt.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.memoriais_descritivos_asbuilt.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.memoriais_descritivos_asbuilt.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return memoriais_descritivos_asbuilt;
};
